      program convertxsn2sf

      IMPLICIT none

      real*8 mp,mp2,pi,alpha,hcsq 
      logical goodfit, thend
      real*8 E,theta,Ep,Q2,W2,x,sigma,stat,syst,ertot,x1,F2_liang
      real*8 r90,dr90,r98,dr98,F1pmod,F2pmod,rec,r_liang
      real*8 tan2,nu,nu2,kappa,eps,flux,flux1,fluxnum,fluxden,nu1,eps1
      real*8 factor,factorn,factord,f2rl,stf2rl,sysf2rl
      real*8 f2r90,stf2r90,sysf2r90,f2r98,stf2r98,sysf2r98
      real*8 f2rec,stf2rec,sysf2rec,diff,fdiff

      real*4 x4,Q24,r984,dr984
      integer Pt

c      goodfit = .true.

      mp = .9382727
      mp2 = mp*mp   
      pi = 3.141593
      alpha = 1./137.036
      hcsq = 0.389379e6  !! units GeV^2 nb
      syst=0.0

      thend = .false.

      open(unit = 11, file = 'E139Fe2612xsn.dat', 
     &     status = 'old')
c$$$      open(unit = 12, file = 'results/new_E94_110.dat', 
c$$$     &     status = 'unknown')
c$$$      open(unit = 13, file = 'results/checks_f2_from_E94_110.dat', 
c$$$     &     status = 'unknown')
c$$$      open(unit = 14, file = 'results/checks_kinematics.dat', 
c$$$     &     status = 'unknown')
      read(11,*) 
      

      dowhile(.not.thend)
      

c      read(11,*,END=9999) E,Ep,theta,Q2,W2,nu1,eps1,flux1,x1,sigma,stat
      read(11,*,END=9999) E,Ep,theta,Pt,sigma,stat,syst

c      write(6,*) 'data: ', E,Ep,theta,Pt,sigma,stat,syst   

      ertot = sqrt(stat**2 + syst**2)

      nu = E - Ep
      Q2 = 4.*E*Ep*(sin(theta*pi/360.))**2
      W2 = mp*mp + 2*mp*nu - Q2
      x=(Q2)/(2*mp*nu)

      call r1990(x,Q2,r90,dr90,goodfit)

      x4 = x
      Q24 = Q2
c      call r1998(x4,Q24,r984,dr984,goodfit)
c      r98 = r984
c      dr98 = dr984 

c      call mod_liang(Q2,W2,F2_liang,r_liang)    
      
      call F1F2IN09(26.D0, 56.D0, Q2, W2, F1pmod, F2pmod, rec)

      tan2 = tan(theta*pi/180./2.)*tan(theta*pi/180./2.)
      
      

      nu2 = nu*nu

      kappa = (W2-mp2)/2./mp

      eps = 1./(1. + 2. * (1. + nu2/Q2) * tan2)

      fluxnum = alpha * kappa * Ep
      fluxden = 2. * pi * pi * Q2 * E * (1.-eps)

      flux = fluxnum/fluxden

      factorn = nu * kappa
      factord = 4 * pi * pi * alpha * flux * (1 + nu2/Q2)

      factor = factorn/factord

c      write(14,1003) x1,x,nu1,nu,eps1,eps,flux1,flux

      f2r90 = factor * (sigma/hcsq)*(1 + r90)/(1 + eps * r90)
      stf2r90 = factor * (stat/hcsq)*(1 + r90)/(1 + eps * r90)
      sysf2r90 = factor * (syst/hcsq)*(1 + r90)/(1 + eps * r90)

c      f2rl = factor * (sigma/hcsq)*(1 + r_liang)/(1 + eps * r_liang)
c      stf2rl = factor * (stat/hcsq)*(1 + r_liang)/(1 + eps * r_liang)
c      sysf2rl = factor * (syst/hcsq)*(1 + r_liang)/(1 + eps * r_liang)

      f2rec = factor * (sigma/hcsq)*(1 + rec)/(1 + eps * rec)
      f2rec = f2rec/56.d0
      stf2rec = factor * (stat/hcsq)*(1 + rec)/(1 + eps * rec)
      stf2rec = stf2rec/56.d0
      sysf2rec = factor * (syst/hcsq)*(1 + rec)/(1 + eps * rec)
      sysf2rec = sysf2rec/56.d0

c      diff=sqrt((f2rl-f2rec)*(f2rl-f2rec))
      diff=f2rl-f2rec
c      diff=diff * diff
c      diff=sqrt(diff)
      fdiff=(diff)/(f2rl)
c     fdiff : fractional difference

c      write(6,1001) x,Q2,W2,eps,sigma,stat,syst,f2r90,stf2r90,
c     &     sysf2r90,f2rl,stf2rl,sysf2rl,F2_liang,f2rec,stf2rec,sysf2rec,
c     &     F2pmod,fdiff

      write(6,1001) x,Q2,f2rec,stf2rec,sysf2rec

c      write(6,1002) x,Q2,W2,f2r90,stf2r90,
c     &     sysf2r90,f2rec,stf2rec,sysf2rec,
c     &     F2pmod,r90,rec

c      write(6,*) 'diff, fdiff, f2rl, f2rec: ', diff,fdiff,f2rl,f2rec

      enddo

 9999 thend = .true.
 1001 format(5f10.4)
 1002 format(12f10.4)
c  1003 format(8f10.4)
 1003 format(f10.3,f10.4,f10.3,f10.4,f10.3,f10.4,f10.3,f10.4)
      close(11)
      close(12)

      end
